X.509 Certificate Extended Key Usage (EKU) for Configuration, Updates, and Safety-Critical Communication
RFC 9809
Hendrik Brockhaus
Siemens
Werner-von-Siemens-Strasse 1
Munich
80333
Germany
hendrik.brockhaus@siemens.com
https://www.siemens.com
David Goltzsche
Siemens Mobility
Ackerstrasse 22
Braunschweig
38126
Germany
david.goltzsche@siemens.com
https://www.mobility.siemens.com
July 2025
SEC
lamps
Industrial Automation
ERJU
extended key usage
extension
PKI
RFC 5280 defines the Extended Key Usage (EKU) extension and specifies several extended key purpose identifiers (KeyPurposeIds) for use with that extension in X.509 certificates. This document defines KeyPurposeIds for general-purpose and trust anchor configuration files, for software and firmware update packages, and for safety-critical communication to be included in the EKU extension of X.509 v3 public key certificates.
Introduction
Key purpose identifiers (KeyPurposeIds) added to the certificate's EKU extension [RFC5280] are meant to express intent as to the purpose of the named usage, for humans and complying libraries. A full list of KeyPurposeIds is maintained in the IANA registry "SMI Security for PKIX Extended Key Purpose" [SMI-PKIX-PURPOSE]. The use of the anyExtendedKeyUsage KeyPurposeId, as defined in Section 4.2.1.12 of [RFC5280], is generally considered a poor practice.
This document defines KeyPurposeIds for certificates that are used for the following purposes, among others:
- Validating signatures of general-purpose software configuration files.
- Validating signatures of trust anchor configuration files.
- Validating signatures of software and firmware update packages.
- Authenticating communication endpoints authorized for safety-critical communication.
If the purpose of an issued certificate is not restricted (i.e., the operations of the public key contained in the certificate can be used in unintended ways), the risk of cross-application attacks is increased. Failure to ensure adequate segregation of duties means that an application or system that generates the public/private keys and applies for a certificate to the operator Certification Authority (CA) could obtain a certificate that can be misused for tasks that this application or system is not entitled to perform. For example, management of trust anchors is a particularly critical task. A device could potentially accept a trust anchor configuration file signed by a service that uses a certificate with no EKU or with the KeyPurposeIds id-kp-codeSigning (Section 4.2.1.12 of [RFC5280]) or id-kp-documentSigning [RFC9336]. A device should only accept trust anchor configuration files if the file is verified with a certificate that has been explicitly issued for this purpose.
The KeyPurposeId id-kp-serverAuth (Section 4.2.1.12 of [RFC5280]) can be used to identify that the certificate is for a TLS WWW server, and the KeyPurposeId id-kp-clientAuth (Section 4.2.1.12 of [RFC5280]) can be used to identify that the certificate is for a TLS WWW client. However, there are currently no KeyPurposeIds for usage with X.509 certificates for safety-critical communication.
This document addresses the above problems by defining KeyPurposeIds for the EKU extension of X.509 public key certificates. These certificates are used either for signing files (general-purpose configuration files, trust anchor configuration files, and software and firmware update packages) or for safety-critical communication.
Vendor-defined KeyPurposeIds used within a PKI governed by vendors typically do not pose interoperability concerns, as non-critical extensions can be safely ignored if unrecognized. However, using KeyPurposeIds outside of their intended vendor-controlled environment or in ExtendedKeyUsage extensions that have been marked critical can lead to interoperability issues. Therefore, it is advisable not to rely on vendor-defined KeyPurposeIds. Instead, this specification defines standard KeyPurposeIds to ensure interoperability across various vendors and industries.
The definitions of these KeyPurposeIds are intentionally broad to allow their use in different deployments even though they were initially motivated by industrial automation and rail automation (see Appendix B). The details for each deployment need to be described in the relevant technical standards and certificate policies.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
This document uses terms defined in [RFC5280]. X.509 certificate extensions are defined using ASN.1 [X.680] [X.690].
The term "safety-critical communication" refers to communication that could, under certain conditions, lead to a state in which human life, health, property, or the environment is endangered. For the definition of "safety", see [NIST.SP.800-160] and [ISO.IEC.IEEE_12207].
Extended Key Purpose for Configuration Files, Update Packages, and Safety-Critical Communication
This specification defines the following KeyPurposeIds:
- id-kp-configSigning: Used for signing general-purpose configuration files.
- id-kp-trustAnchorConfigSigning: Used for signing trust anchor configuration files.
- id-kp-updatePackageSigning: Used for signing software or firmware update packages.
- id-kp-safetyCommunication: Used for authenticating communication peers for safety-critical communication.
As described in Section 4.2.1.12 of [RFC5280], "[i]f the [extended key usage] extension is present, then the certificate MUST only be used for one of the purposes indicated", and "[i]f multiple [key] purposes are indicated the application need not recognize all purposes indicated, as long as the intended purpose is present".
None of the KeyPurposeIds specified in this document are intrinsically mutually exclusive. Instead, the acceptable combinations of those KeyPurposeIds with others specified in this document and with other KeyPurposeIds specified elsewhere are left to the technical standards of the respective application and the certificate policy of the respective PKI. For example, a technical standard may specify the following: "Different keys and certificates must be used for safety-critical communication and for trust anchor updates, and a relying party must ignore the KeyPurposeId id-kp-trustAnchorConfigSigning if id-kp-safetyCommunication is one of the specified key purposes in a certificate." For example, the certificate policy may specify the following: "The id-kp-safetyCommunication KeyPuposeId should not be included in an issued certificate together with the KeyPurposeId id-kp-trustAnchorConfigSigning." Technical standards and certificate policies of different applications may specify other rules. Further considerations on prohibiting combinations of KeyPurposeIds is described in Section 6.
Systems or applications that verify the signature of a general-purpose configuration file or trust anchor configuration file, the signature of a software or firmware update package, or the authentication of a communication peer for safety-critical communication SHOULD require that corresponding KeyPurposeIds be specified by the EKU extension. If the certificate requester knows the certificate users are mandated to use these KeyPurposeIds, it MUST enforce their inclusion. Additionally, such a certificate requester MUST ensure that the Key Usage extension be set to digitalSignature for signature verification, to keyEncipherment for public key encryption, and keyAgreement for key agreement.
Including the Extended Key Purpose in Certificates
[RFC5280] specifies the EKU X.509 certificate extension for use on end-entity certificates. The extension indicates one or more purposes for which the certified public key is valid. The EKU extension can be used in conjunction with the Key Usage (KU) extension, which indicates the set of basic cryptographic operations for which the certified key may be used. The EKU extension syntax is repeated here for convenience:

   ExtKeyUsageSyntax  ::=  SEQUENCE SIZE (1..MAX) OF KeyPurposeId

   KeyPurposeId  ::=  OBJECT IDENTIFIER

As described in [RFC5280], the EKU extension may, at the option of the certificate issuer, be either critical or non-critical. The inclusion of KeyPurposeIds id-kp-configSigning, id-kp-trustAnchorConfigSigning, id-kp-updatePackageSigning, and id-kp-safetyCommunication in a certificate indicates that the public key encoded in the certificate has been certified for the following usages:
- id-kp-configSigning
A public key contained in a certificate containing the KeyPurposeId id-kp-configSigning may be used for verifying signatures of general-purpose configuration files of various formats (e.g., XML, YAML, or JSON). Configuration files are used to configure hardware or software.
- id-kp-trustAnchorConfigSigning
A public key contained in a certificate containing the KeyPurposeId id-kp-trustAnchorConfigSigning may be used for verifying signatures of trust anchor configuration files of various formats (e.g., XML, YAML, or JSON). Trust anchor configuration files are used to add or remove trust anchors to the trust store of a device.
- id-kp-updatePackageSigning
A public key contained in a certificate containing the KeyPurposeId id-kp-updatePackageSigning may be used for verifying signatures of software or firmware update packages. Update packages are used to install software (including bootloader, firmware, safety-related applications, and others) on systems.
- id-kp-safetyCommunication
A public key contained in a certificate containing the KeyPurposeId id-kp-safetyCommunication may be used to authenticate a communication peer for safety-critical communication based on TLS or other protocols.

   id-kp  OBJECT IDENTIFIER  ::=
       { iso(1) identified-organization(3) dod(6) internet(1)
         security(5) mechanisms(5) pkix(7) 3 }

   id-kp-configSigning             OBJECT IDENTIFIER ::= { id-kp 41 }
   id-kp-trustAnchorConfigSigning  OBJECT IDENTIFIER ::= { id-kp 42 }
   id-kp-updatePackageSigning      OBJECT IDENTIFIER ::= { id-kp 43 }
   id-kp-safetyCommunication       OBJECT IDENTIFIER ::= { id-kp 44 }

Implications for a Certification Authority
The procedures and practices employed by a certification authority must ensure that the correct values for the EKU extension and the KU extension are inserted in each certificate that is issued. The inclusion of the id-kp-configSigning, id-kp-trustAnchorConfigSigning, id-kp-updatePackageSigning, and id-kp-safetyCommunication KeyPurposeIds does not preclude the inclusion of other KeyPurposeIds.
Security Considerations
The security considerations of [RFC5280] are applicable to this document. These EKU key purposes do not introduce new security risks but instead reduce existing security risks by providing the means to identify if a certificate is generated to verify the signature of a general-purpose or trust anchor configuration file, the signature of a software or firmware update package, or the authentication of a communication peer for safety-critical communication.
To reduce the risk of specific cross-protocol attacks, the relying party may additionally prohibit use of specific combinations of KeyPurposeIds. The procedure for allowing or disallowing combinations of KeyPurposeIds using excluded KeyPurposeId and permitted KeyPurposeId, as carried out by a relying party, is defined in Section 4 of [RFC9336]. The technical standards and certificate policies of the application should explicitly enumerate requirements for excluded or permitted KeyPurposeIds or their combinations. It is out of scope of this document to enumerate those, but an example of excluded KeyPurposeIds can be the presence of the anyExtendedKeyUsage KeyPurposeId. Examples of allowed KeyPurposeIds combinations can be the presence of id-kp-safetyCommunication together with id-kp-clientAuth or id-kp-serverAuth.
Privacy Considerations
In some protocols (e.g., TLS 1.2 [RFC5246]), certificates are exchanged in the clear. In other protocols (e.g., TLS 1.3 [RFC8446]), certificates are encrypted. The inclusion of the EKU extension can help an observer determine the purpose of the certificate. In addition, if the certificate is issued by a public certification authority, the inclusion of an EKU extension can help an attacker to monitor the Certificate Transparency logs [RFC9162] to identify the purpose of the certificate, which may reveal private information of the certificate subject.
IANA Considerations
IANA has registered the following ASN.1 [X.680] module OID in the "SMI Security for PKIX Module Identifier" registry [SMI-PKIX-MOD]. This OID is defined in Appendix A.
Decimal | Description | Reference
117 | id-mod-config-update-sc-eku | RFC 9809
IANA has also registered the following OIDs in the "SMI Security for PKIX Extended Key Purpose" registry [SMI-PKIX-PURPOSE]. These OIDs are defined in Section 4.
Decimal | Description | Reference
41 | id-kp-configSigning | RFC 9809
42 | id-kp-trustAnchorConfigSigning | RFC 9809
43 | id-kp-updatePackageSigning | RFC 9809
44 | id-kp-safetyCommunication | RFC 9809
References
Normative References
[X.680]

Information Technology - Abstract Syntax Notation One (ASN.1): Specification of basic notation
ITU-T
February 2021
ITU-T Recommendation X.680
[X.690]

Information Technology - ASN.1 encoding rules: Specification of Basic Encoding Rules (BER), Canonical Encoding Rules (CER) and Distinguished Encoding Rules (DER)
ITU-T
February 2021
ITU-T Recommendation X.690
Informative References
[Directive-2016_797]

Directive (EU) 2016/797 of the European Parliament and of the Council of 11 May 2016 on the interoperability of the rail system within the European Union
European Parliament, Council of the European Union
May 2020
[ERJU]

Shared Cybersecurity Services Specification - SP-SEC-ServSpec - V1.0
Europe's Rail Joint Undertaking
February 2025
[ERJU-web]

Europe's Rail Joint Undertaking - System Pillar
Europe's Rail Joint Undertaking
[EU-CRA]

Regulation (EU) 2024/2847 of the European Parliament and of the Council of 23 October 2024 on horizontal cybersecurity requirements for products with digital elements and amending Regulations (EU) No 168/2013 and (EU) 2019/1020 and Directive (EU) 2020/1828 (Cyber Resilience Act)
European Commission
November 2024
[EU-STRATEGY]

The EU's Cybersecurity Strategy for the Digital Decade
European Commission
December 2020
[NIST.SP.800-160]

Engineering Trustworthy Secure Systems
Ron Ross
Mark Winstead
Michael McEvilley
November 2022
NIST SP 800-160v1r1
DOI 10.6028/NIST.SP.800-160v1r1
[ISO.IEC.IEEE_12207]

Systems and software engineering - Software life cycle processes
ISO/IEC/IEEE
November 2017
ISO/IEC/IEEE 12207:2017
[NIS2]

Directive (EU) 2022/2555 of the European Parliament and of the Council
European Commission
December 2024
[IEC.62443-4-2]

Security for industrial automation and control systems - Part 4-2: Technical security requirements for IACS components
IEC
February 2019
IEC 62443-4-2:2019
[IEC.62443-3-3]

Industrial communication networks - Network and system security - Part 3-3: System security requirements and security levels
IEC
August 2013
IEC 62443-3-3:2013
[CE-marking]

CE marking
European Commission
[SMI-PKIX-PURPOSE]

SMI Security for PKIX Extended Key Purpose
IANA
[SMI-PKIX-MOD]

SMI Security for PKIX Module Identifier
IANA
[RFC5280]
[RFC9336]
[RFC2119]
[RFC8174]
[RFC5246]
[RFC8446]
[RFC9162]
[RFC9509]
ASN.1 Module
The following module adheres to ASN.1 specifications [X.680] and [X.690].

<CODE BEGINS>

Automation-EKU
  { iso(1) identified-organization(3) dod(6) internet(1)
    security(5) mechanisms(5) pkix(7) id-mod(0)
    id-mod-config-update-sc-eku (117) }

DEFINITIONS IMPLICIT TAGS ::=
BEGIN

-- OID Arc

id-kp OBJECT IDENTIFIER ::=
  { iso(1) identified-organization(3) dod(6) internet(1)
    security(5) mechanisms(5) pkix(7) kp(3) }

-- Extended Key Usage Values

id-kp-configSigning            OBJECT IDENTIFIER ::= { id-kp 41 }
id-kp-trustAnchorConfigSigning OBJECT IDENTIFIER ::= { id-kp 42 }
id-kp-updatePackageSigning     OBJECT IDENTIFIER ::= { id-kp 43 }
id-kp-safetyCommunication      OBJECT IDENTIFIER ::= { id-kp 44 }

END

<CODE ENDS>

Use Cases
These use cases are only for informational purposes.
Automation hardware and software products strive to become more safe and secure by fulfilling mandatory, generic system requirements related to cybersecurity, e.g., driven by federal offices like the European Union Cyber Resilience Act [EU-CRA] governed by the European Commission and the High Representative of the Union for Foreign Affairs and Security Policy. Automation products connected to the Internet and sold in the EU after 2027 must bear the so-called "CE marking" [CE-marking] to indicate that they comply with the EU-CRA. Such regulation was announced in the 2020 EU Cybersecurity Strategy [EU-STRATEGY] and complements other legislation in this area, like the directive on measures for a high common level of cybersecurity for network and information systems (NIS) across the European Union [NIS2].
The 2020 EU Cybersecurity Strategy [EU-STRATEGY] suggests implementing and extending international standards such as [IEC.62443-4-2] and [IEC.62443-3-3]. Automation hardware and software products of diverse vendors that are connected on automation networks and the Internet can be used to build common automation solutions. Standardized attributes would allow transparency of security properties and interoperability for vendors in the context of software and firmware updates, general-purpose configuration, trust anchor configuration, and safety-critical communication.
A concrete example for automation is a rail automation system. The Europe's Rail web page [ERJU-web] states:
The System Pillar brings rail sector representatives under a single coordination body. To achieve this, the System Pillar will deliver a unified operational concept and a functional, safe and secure system architecture, with due consideration of cyber-security aspects, focused on the European railway network to which Directive 2016/797 applies (i.e. the heavy rail network) as well as associated specifications and/or standards.
See [Directive-2016_797]. For details about the System Pillar, see [ERJU].
Acknowledgments
We would like to thank the authors of [RFC9336] and [RFC9509] for their excellent template.
We also thank all reviewers of this document for their valuable feedback.
Contributors
Szofia Fazekas-Zisch
Siemens AG
Breslauer Str. 5
Fuerth
90766
Germany
szofia.fazekas-zisch@siemens.com
https://www.siemens.com
Baptiste Fouques
Alstom
baptiste.fouques@alstomgroup.com
Daniel Gutierrez Orta
CAF Signalling
daniel.gutierrez@cafsignalling.com
Martin Weller
Hitachi Rail
martin.weller@urbanandmainlines.com
Nicolas Poyet
SNCF
nicolas.poyet@sncf.fr